package com.sample;

import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

import org.drools.SystemEventListenerFactory;
import org.jbpm.task.User;
import org.jbpm.task.service.TaskService;
import org.jbpm.task.service.TaskServiceSession;
import org.jbpm.task.service.mina.MinaTaskServer;

import bitronix.tm.resource.jdbc.PoolingDataSource;

public class TaskServer {

	/**
	 * @param args
	 */
	public static final void main(String[] args) {
		
		try {
			
			PoolingDataSource ds1 = new PoolingDataSource();
	       
			
			//sample H2 database configuration
			
			
			ds1.setClassName("bitronix.tm.resource.jdbc.lrc.LrcXADataSource");
	    	ds1.setUniqueName("jdbc/testDS1");
	    	ds1.setMaxPoolSize(5);
	    	ds1.setAllowLocalTransactions(true);
	    	ds1.getDriverProperties().setProperty("driverClassName", "org.h2.Driver");
	    	ds1.getDriverProperties().setProperty("url", "jdbc:h2:tcp://localhost/JPADroolsFlow");
	    	ds1.getDriverProperties().setProperty("user", "sa");
	    	ds1.getDriverProperties().setProperty("password", "");
	    	
	    	
			//Sample Oracle datasource configuration
	    	/*
			ds1.setUniqueName( "jdbc/testDS1" );
	        ds1.setClassName( "oracle.jdbc.xa.client.OracleXADataSource" );
	        ds1.setMaxPoolSize( 3 );
	        ds1.setAllowLocalTransactions( true );
	        ds1.getDriverProperties().put( "user","user" );
	        ds1.getDriverProperties().put( "password","pw" );
	        ds1.getDriverProperties().put( "URL",
	        "jdbc:oracle:thin:@oracleserver:1521:db" );
			*/
	    	
	    	/*
			    ds1 = new PoolingDataSource();
		        ds1.setUniqueName( "jdbc/testDS1" );
		        ds1.setClassName( "com.mysql.jdbc.jdbc2.optional.MysqlXADataSource" );
		        
		        ds1.setMaxPoolSize( 3 );
		        ds1.setAllowLocalTransactions( true );
		        ds1.getDriverProperties().put( "user",
		                                       "user" );
		        ds1.getDriverProperties().put( "password",
		                                       "pw" );
		        ds1.getDriverProperties().put( "URL",
		                                     "jdbc:mysql://mysqlserver:3306/jbpm5db" );
            */
	     
	                ds1.init();	
	      			
			EntityManagerFactory emfTask = Persistence.createEntityManagerFactory( "org.jbpm.task" );
			TaskService taskService = new TaskService(emfTask, SystemEventListenerFactory.getSystemEventListener());
			
			
			
			/*
	         * Add the required users 
	         */
	        TaskServiceSession taskSession = taskService.createSession();   
	        taskSession.addUser(new User("Administrator"));
	        taskSession.addUser(new User("krisv")); 
	        taskSession.addUser(new User("john")); 
	        
	        /* Start Mina server for HT*/
	        MinaTaskServer server = new MinaTaskServer(taskService);
	        Thread thread = new Thread(server);
	        thread.start();
	        System.out.println("Server started ..."); 
	       
		
		} catch (Throwable t) {
			t.printStackTrace();
		}
	}


	
	

}
